// Copyright (C) 2004-2007  Autodesk, Inc.
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of version 2.1 of the GNU Lesser
// General Public License as published by the Free Software Foundation.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#ifndef _CONNECTIONINFOTEST_H_
#define _CONNECTIONINFOTEST_H_
#ifdef _WIN32
#pragma once
#endif

#ifndef CPP_UNIT_CONNECTIONINFOTEST_H
#define CPP_UNIT_CONNECTIONINFOTEST_H

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
#include <Fdo.h>
#include <TestCommonMiscUtil.h>

/* 
 * Checks whether or not the provider type and list of dependent files
 * are reported correctly.
 */

class ConnectionInfoTest : public CppUnit::TestCase
{
  CPPUNIT_TEST_SUITE( ConnectionInfoTest );
  CPPUNIT_TEST( TestProviderInfo );
  CPPUNIT_TEST_SUITE_END();

public:
    ConnectionInfoTest();
    virtual ~ConnectionInfoTest();
    void setUp();

protected:
    void TestProviderInfo();

private:
    FdoIConnection *CreateDb();
};

#endif
#endif
